// pages/childMatch/childMatch.js
import httpRequestApi from '../../utils/APIRequest';
Page({

  /**
   * 页面的初始数据
   */
  data: {
    photoBoxList: [],
    hiddenFlag: true,
    page: 1,
    totalSize: 0
  },

  //点击跳转到相册
  album: ({ currentTarget }) => {
    console.log(currentTarget)
    wx.navigateTo({
      url: `/pages/access/access?id=${currentTarget.id}`
    })
  },
  //萌娃相册的搜素
  focus: function ({detail}) {
    if (detail.value) {
      httpRequestApi.getPhotoBoxList({
        name: detail.value
      }).success((res) => {
        console.log('萌娃相册搜索结果', res)
        this.setData({
          photoBoxList: res.data.data.list
        })
        if(res.data.data.list.length == 0) {
          this.setData({
            hiddenFlag: false
          })
        }else {
          this.setData({
            hiddenFlag: true
          })
        }
      })
    }else {
      this.getPhotoBoxList(1, 7);
      this.setData({
        hiddenFlag: true
      })
    }
  },
  /**
   * 生命周期函数--监听页面加载
   */
  onLoad: function (options) {
    if(options.share && !wx.getStorageSync('uid')) {
      wx.reLaunch({
        url: '/pages/index/index?ind=0'
      })
      return false;
    }
    this.getPhotoBoxList(1, 7);
  },

  getPhotoBoxList(pageNo, pageSize) {
    httpRequestApi.getPhotoBoxList({
      pageNo,
      pageSize
    }).success((res) => {
      this.setData({
        photoBoxList: res.data.data.list,
        totalSize: res.data.data.totalSize
      })
      wx.hideLoading();
    })
  },

  /**
   * 生命周期函数--监听页面初次渲染完成
   */
  onReady: function () {

  },

  /**
   * 生命周期函数--监听页面显示
   */
  onShow: function () {
    this.getPhotoBoxList(1, 7);
  },

  /**
   * 生命周期函数--监听页面隐藏
   */
  onHide: function () {

  },

  /**
   * 生命周期函数--监听页面卸载
   */
  onUnload: function () {

  },

  /**
   * 页面相关事件处理函数--监听用户下拉动作
   */
  onPullDownRefresh: function () {

  },

  /**
   * 页面上拉触底事件的处理函数
   */
  onReachBottom: function () {

  },

  /**
   * 用户点击右上角分享
   */
  onShareAppMessage: function () {
    return {
      title: '七彩童年',
      path: `pages/childMatch/childMatch?share=true`,
      success: function (res) {
        // 转发成功
        console.log("转发成功:" + JSON.stringify(res));
        // var shareTickets = res.shareTickets;
        // if (shareTickets.length == 0) {
        //   return false;
        // }
        // //可以获取群组信息
        // wx.getShareInfo({
        //   shareTicket: shareTickets[0],
        //   success: function (res) {
        //     console.log(res)
        //   }
        // })
      },
      fail: function (res) {
        // 转发失败
        console.log("转发失败:" + JSON.stringify(res));
      }
    }
  },
  /*上拉加载更多*/
  onBottom: function (e) {
    if(this.data.totalSize <= 10 * this.data.page){
      return false;
    }
    wx.showLoading({
      title: '加载中。。。。。。',
    })
    setTimeout( () => {
      this.data.page++;
      this.setData({
        page: this.data.page++
      })
      this.getPhotoBoxList(1, 10 * this.data.page);
    },2000)
  }
})